/**************************************
 * NOTE: This source code is free and 
 * comes with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2006
 * 
 **************************************/

var FeedbackFox = {
	
	windowMediator 			: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
	prefService 			: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
	promptService 			: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
	profileDirectory 		: Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsILocalFile),
	ioService 				: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),
	secretDecoderRing 		: Components.classes["@mozilla.org/security/sdr;1"].getService(Components.interfaces.nsISecretDecoderRing),
	inputStream 			: Components.classes["@mozilla.org/network/file-input-stream;1"],
	converterInputStream 	: Components.classes["@mozilla.org/intl/converter-input-stream;1"],
	scriptableInputStream 	: Components.classes["@mozilla.org/scriptableinputstream;1"],
	outputStream 			: Components.classes["@mozilla.org/network/file-output-stream;1"],
	converterOutputStream 	: Components.classes["@mozilla.org/intl/converter-output-stream;1"],
	cService 				: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),

	regexStringBundle : null,
	chrome : 'chrome://feedbackfox/skin/icon',
	// global variables
	topWin : null,
	optWnd : null,
	browser : null,
	numberOfPages : 1,
	statePanel : null,
	fbUrl : "",
	receivedUrl : "http://feedback.ebay.com/ws/eBayISAPI.dll?ViewFeedback2&userid=",
	leftUrl : "http://feedback.ebay.com/ws/eBayISAPI.dll?ViewFeedback2&ftab=FeedbackLeftForOthers&userid=",
	pagesContent : "",
	fbCount : 0,
	http_request_content : false,
	type : "",
	firstPageProcessed : false,
	allFinished : false,
	currentPage : 1,
	itemTab : null,
	contextMenu : null,
	locked : false,
	username : "",
	tmp : "",
	gChromeState : {},
	sidebar : "",
	sidebarBox : "",
	sidebarCurrentTitle : "",
	textfield : null,
	isItemView : false,
	aTab : "",
	progress : null,
	aCommandID : null,
	userid : "",
	maxfeedbackcount : 1000,
	currentDirection : "received",
	characteristic : "sellbuy",
	// internationalization string variables
	locale : "",
	nouserid : "",
	noitemview : "",
	seller : "",
	buyer : "",
	leftby : "",
	leftfor : "",
	privateAuction : "",
	itemnotavailable : "",
	load : "",
	loadingerror : "",
	oneFb : "",
	moreThanOneFB : "",
	no : "",
	// types
	positive : "",
	neutral : "",
	negative : "",
	withdrawn : "",
	// localized month
	jan : "",
	feb : "",
	mar : "",
	apr : "",
	may : "",
	jun : "",
	jul : "",
	aug : "",
	sep : "",
	oct : "",
	nov : "",
	dec : "",
	// localized day
	mon : "",
	tue : "",
	wed : "",
	thu : "",
	fri : "",
	sat : "",
	sun : "",
	// date
	days : "",
	months : "",
	// a variable for the top level domain extension
	tld : "",

	init: function() {

		window.removeEventListener('load', function() { FeedbackFox.init(); } , false);
		this.topWin = this.windowMediator.getMostRecentWindow("navigator:browser");
		this.browser = this.topWin.getBrowser();
		try {
			var mfc = this.prefService.getCharPref("extensions.feedbackfox.maxfeedbackcount");
			this.maxfeedbackcount = parseInt(mfc);
			this.log("maxfeedbackcount: " + mfc);
		} catch (e) {
			this.log("init: " + e);
		}
		return true;
	},

	log: function(msg) {
		this.cService.logStringMessage("Feedbackfox: " + msg);
	},

	notify: function(msg) {
		var img = "chrome://feedbackfox/skin/feedbackfox_icon_32x32.png";
		var comp = Components.classes["@growl.info/notifications;1"];
		if (comp) {
			var gGrowl = comp.getService(Components.interfaces.grINotifications);
			if (gGrowl) {
				gGrowl.sendNotification("FBF Message", img, "Feedbackfox", msg, "", null);
			} else {
				dump("GrowlNotifier not available\n");
			}
		} else {
			try {
				var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
						.getService(Components.interfaces.nsIAlertsService);
				alertsService.showAlertNotification(img, "Feedbackfox", msg, false, "", null);
			} catch (e) {
				var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
						.getService(Components.interfaces.nsIPromptService);
				promptService.alert(null, "Feedbackfox", msg);
			}
		}
	},

	prepareFbfMenu: function(menu) {

		while (menu.firstChild) {
			menu.removeChild(menu.firstChild);
		}
		var userList = new Array();
		var name = "";
		var links = null;
		var tabDoc = content.document;
		if (tabDoc.URL.match(/ebay.+ViewItem/)) {
			links = tabDoc.links;
		} else if (tabDoc.URL.match(/ebay.+ViewBids/)) {
			links = tabDoc.links;
		}
		if (links) {
			for ( var i = 0; i < links.length; i++) {
				var li = String(links[i]);
				// http://myworld.ebay.de/real-smart-buy/
				name = li.match(/http:\/\/myworld.ebay.*?\/(.*?)\// );
				if (name != null) {
					name = name[1];
					name = String(name);
					if (!this.containsName(userList, name)) {
						userList.push(name);
					}
				}
			}
			userList.sort();
			while (userList.length > 0) {
				name = userList.shift();
				var item = document.createElement('menuitem');
				item.setAttribute('label', name);
				item.setAttribute('oncommand',
								  "FeedbackFox.invokeFbfContextMenuEvent('viewfeedbackfoxSidebar',label);");
				menu.appendChild(item);
			}
		}
	},

	containsName: function(array, string) {

		for ( var i = 0; i < array.length; i++) {
			if (array[i] == string) {
				return true;
			}
		}
		return false;
	},

	registerContextMenuListener: function() {

		var context = document.getElementById("contentAreaContextMenu");
		if (context) {
			context.addEventListener("popupshowing", function() { FeedbackFox.updateFbfContextMenu(); }, true);
		}
	},

	updateFbfContextMenu: function() {

		this.topWin = this.windowMediator.getMostRecentWindow("navigator:browser");
		this.browser = this.topWin.getBrowser();
		this.aTab = this.browser.selectedTab;
		var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
		var tabDoc = content.document;
		if (tabDoc.URL.match(/ebay.+ViewItem/)) {
			feedbackfoxmenuitem.hidden = false;
			this.isItemView = true;
		} else if (tabDoc.URL.match(/ebay.+ViewBids/)) {
			feedbackfoxmenuitem.hidden = false;
			this.isItemView = true;
		} else {
			feedbackfoxmenuitem.hidden = true;
			this.isItemView = false;
		}
	},

	invokeFbfContextMenuEvent: function(command, name) {

		this.aCommandID = command;
		this.username = name;
		this.setTout(function() { FeedbackFox.processFbfContextMenuEvent(); }, 10);
	},

	processFbfContextMenuEvent: function() {

		this.reset();
		this.sidebar = document.getElementById("sidebar");
		this.sidebarBox = document.getElementById("sidebar-box");
		this.sidebarCurrentTitle = document.getElementById("sidebar-title").getAttribute("value");
		this.gChromeState.sidebarOpen = !this.sidebarBox.hidden;
		var state_on = (this.sidebarCurrentTitle == "Feedbackfox");
		if (!this.gChromeState.sidebarOpen || !state_on) {
			this.sidebarBox.setAttribute('src', 'chrome://feedbackfox/content/sidebar.xul');
			toggleSidebar(this.aCommandID);
			this.sidebar.addEventListener('load', function() { FeedbackFox.getUserFeedback(); }, true);
		} else {
			this.setTout(function() { FeedbackFox.getUserFeedback(); }, 10);
		}
	},

	getUserFeedback: function() {

		this.sidebar.removeEventListener('load', function() { FeedbackFox.getUserFeedback(); }, true);
		this.textfield = this.sidebar.contentDocument.getElementById("username-field");
		this.textfield.value = "";
		this.textfield.value = this.username;
		var receivedButton = this.sidebar.contentDocument.getElementById('receivedButton');
		receivedButton.doCommand();
	},

	getSellerName: function() {

		var itemContent = "";
		var tabDoc = content.document;
		if (tabDoc.URL.match(/ebay.+ViewItem/)) {
			var itemURL = tabDoc.URL;
			FeedbackFox.http_request_content = new XMLHttpRequest();
			FeedbackFox.http_request_content.open('GET', itemURL, false);
			FeedbackFox.http_request_content.send(null);
			if (FeedbackFox.http_request_content.readyState == 4) {
				if (FeedbackFox.http_request_content.status == 200) {
					itemContent = FeedbackFox.http_request_content.responseText;
					var elements = itemContent.match(/ViewFeedback&amp;userid=(\S+)&amp./); 
					this.username = elements[1];
				}
			}
		}
	},

	/* causes the feedbackfox-sidebar input objects are locked */
	lock: function() {

		if (!this.locked) {
			var fbftreecols = document.getElementById('fbftreecols').childNodes;
			for ( var i = 0; i < fbftreecols.length; i++) {
				var child = fbftreecols[i];
				child.removeAttribute('onclick');
			}
			var receivedButton = document.getElementById("receivedButton");
			receivedButton.disabled = true;
			var leftButton = document.getElementById("leftButton");
			leftButton.disabled = true;
			var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
			if (this.isItemView) {
				this.feedbackfoxmenuitem.disabled = true;
			}
		}
		this.locked = true;
	},

	/* causes the feedbackfox-sidebar input objects are unlocked */
	unlock: function() {

		if (this.locked) {
			var receivedButton = document.getElementById("receivedButton");
			receivedButton.disabled = false;
			var leftButton = document.getElementById("leftButton");
			leftButton.disabled = false;
			var feedbackfoxmenuitem = document.getElementById("feedbackfox-menuitem");
			if (this.isItemView) {
				this.feedbackfoxmenuitem.disabled = false;
			}
			var fbftreecols = document.getElementById('fbftreecols').childNodes;
			for ( var i = 0; i < fbftreecols.length; i++) {
				var child = fbftreecols[i];
				child.setAttribute('onclick', 'sortcolumn(this);');
			}
		}
		this.locked = false;
	},

	processClickEvent: function(object) {
		
		if (object.id == 'posButton') {
			object.image = this.chrome + 'Poshover_16x16.gif';
		} else if (object.id == 'neuButton') {
			object.image = this.chrome + 'Neuhover_16x16.gif';
		} else if (object.id == 'negButton') {
			object.image = this.chrome + 'Neghover_16x16.gif';
		}
		this.setTout(function() { FeedbackFox.resetButton(object); }, 300);
	},

	resetUsernameField: function() {
		
		document.getElementById("username-field").value = "";
		this.unlock();
	},

	resetButton: function(object) {

		if (object.id == 'posButton') {
			object.image = this.chrome + 'Pos_16x16.gif';
		} else if (object.id == 'neuButton') {
			object.image = this.chrome + 'Neu_16x16.gif';
		} else if (object.id == 'negButton') {
			object.image = this.chrome + 'Neg_16x16.gif';
		}
		object = null;
	},

	start: function(element, detail, direction) {

		this.textfield = document.getElementById("username-field");
		var olduserid = this.userid;
		this.userid = this.textfield.value;

		if (this.userid == olduserid && direction == this.currentDirection) {
			FbfTree.showAll();
		} else {
			this.reset();
			this.currentDirection = direction;
			this.processClickEvent(element);
			this.getLocalizedStrings();
			this.lock();
			this.switchStatePanel('progress');
			this.setProgressbar('0');
			var table = document.getElementById('list');
			table.removeEventListener('select', function() { FeedbackFox.processRowSelection(); }, false);
			this.reset();
			table.addEventListener('select', function() { FeedbackFox.processRowSelection(); }, false);

			if (!this.userid.match(/\S+/)) {
				var tabDoc = content.document;
				if (tabDoc.URL.match(/ebay.+ViewItem/)) {
					this.username = "";
					this.getSellerName();
					if (this.username.length > 1) {
						this.textfield.value = this.username;
						this.username = "";
						this.start(null, 'all', 'received');
					}
				} else {
					this.setState(this.nouserid);
					this.unlock();
					this.setTout(function() { FeedbackFox.setState(); }, 1000);
				}
			} else if (this.userid.match(/\S+/)) {
				if (direction == 'received') {
					document.getElementById('left').setAttribute('label', this.leftby);
					this.fbUrl = this.receivedUrl + this.userid;
				} else {
					document.getElementById('left').setAttribute('label', this.leftfor);
					this.fbUrl = this.leftUrl + this.userid;
				}
				this.type = detail;
				this.getContent(this.fbUrl);
			}
		}
	},

	getLocalizedStrings: function() {

		var stringBundle = document.getElementById("string-bundle");
		// general strings
		this.locale = this.prefService.getCharPref("general.useragent.locale");
		this.nouserid = stringBundle.getString('nouserid');
		this.noitemview = stringBundle.getString('noitemview');
		this.itemnotavailable = stringBundle.getString('itemnotavailable');
		this.load = stringBundle.getString('load');
		this.loadingerror = stringBundle.getString('loadingerror');
		this.oneFb = stringBundle.getString('oneFb');
		this.moreThanOneFB = stringBundle.getString('moreThanOneFB');
		this.no = stringBundle.getString('no');
		// feedback types
		this.positive = stringBundle.getString('positive');
		this.neutral = stringBundle.getString('neutral');
		this.negative = stringBundle.getString('negative');
		this.withdrawn = stringBundle.getString('withdrawn');
		// seller and buyer
		this.seller = stringBundle.getString('seller');
		this.buyer = stringBundle.getString('buyer');
		this.leftby = stringBundle.getString('leftby');
		this.leftfor = stringBundle.getString('leftfor');
		this.privateAuction = stringBundle.getString('private');
		// date related strings
		this.jan = stringBundle.getString('jan');
		this.feb = stringBundle.getString('feb');
		this.mar = stringBundle.getString('mar');
		this.apr = stringBundle.getString('apr');
		this.may = stringBundle.getString('may');
		this.jun = stringBundle.getString('jun');
		this.jul = stringBundle.getString('jul');
		this.aug = stringBundle.getString('aug');
		this.sep = stringBundle.getString('sep');
		this.oct = stringBundle.getString('oct');
		this.nov = stringBundle.getString('nov');
		this.dec = stringBundle.getString('dec');
		this.mon = stringBundle.getString('mon');
		this.tue = stringBundle.getString('tue');
		this.wed = stringBundle.getString('wed');
		this.thu = stringBundle.getString('thu');
		this.fri = stringBundle.getString('fri');
		this.sat = stringBundle.getString('sat');
		this.sun = stringBundle.getString('sun');
		// organize them for easy access
		this.days = new Array(this.sun, this.mon, this.tue, this.wed, this.thu, this.fri, this.sat);
		this.months = new Array(this.jan, this.feb, this.mar, this.apr, this.may, this.jun, this.jul, this.aug, this.sep, this.oct, this.nov, this.dec);
	},

	getTLD: function() {

		this.locale = this.prefService.getCharPref("general.useragent.locale");
		this.locale = (this.locale.length > 2) ? this.locale.substring(3).toLowerCase() : this.locale.toLowerCase();
		switch (this.locale) {
		case "at":
			this.tld = "at";
			break;
		case "ch":
			this.tld = "ch";
			break;
		case "de":
			this.tld = "de";
			break;
		case "au":
			this.tld = "com.au"
			break;
		case "ca":
			this.tld = "ca";
			break;
		case "gb":
			this.tld = "co.uk";
			break;
		case "ie":
			this.tld = "ie";
			break;
		case "in":
			this.tld = "in";
			break;
		case "sg":
			this.tld = "com.sg";
			break;
		case "es":
			this.tld = "es";
			break;
		case "it":
			this.tld = "it";
			break;
		case "fr":
			this.tld = "fr";
			break;
		case "be":
			this.tld = "be";
			break;
		case "nl":
			this.tld = "nl";
			break;
		case "pl":
			this.tld = "pl";
			break;
		case "cn":
			this.tld = "com.cn";
			break;
		default:
			this.tld = "com";
			break;
		}
		return this.tld;
	},

	generateStateMessage: function(detail) {
		var label = "";
		if (this.allFinished) {
			if (this.fbCount == 1) {
				if (detail == 'positive') {
					label = this.positive;
				} else if (detail == 'neutral') {
					label = this.neutral;
				} else if (detail == 'negative') {
					label = this.negative;
				} else if (detail == 'withdrawn') {
					label = this.withdrawn;
				} else {
					label = '';
				}
				this.setState("1 " + label + " " + this.oneFb);
			} else {
				if (detail == 'positive') {
					label = this.positive;
				} else if (detail == 'neutral') {
					label = this.neutral;
				} else if (detail == 'negative') {
					label = this.negative;
				} else if (detail == 'withdrawn') {
					label = this.withdrawn;
				} else {
					label = '';
				}
				this.setState(this.fbCount + " " + label + " " + this.moreThanOneFB);
			}
			this.unlock();
		}
	},

	getNumberOfPages: function(content) {

		var found = false;
		this.regexStringBundle = document.getElementById("fbf-regex-bundle");
		var com = this.regexStringBundle.getString('numberofpages');
		com = new RegExp(com);
		try {
			var tmp = null;
			tmp = content.match(com);
			if (tmp != null && tmp[1] != null) {
				tmp = tmp[1].replace(/\,/, "");
				this.numberOfPages = parseInt(tmp);
				if (this.numberOfPages) {
					found = true;
					try {
						var mfc = this.prefService.getCharPref("extensions.feedbackfox.maxfeedbackcount");
						this.maxfeedbackcount = parseInt(mfc);
					} catch (e) {
					}
					var maxNumber = Math.ceil(this.maxfeedbackcount / 25);
					if (this.numberOfPages > maxNumber) {
						this.numberOfPages = maxNumber;
					}
				}
			}
		} catch (e) {
			this.log("getNumberOfPages: " + e);
			this.setState(this.loadingerror);
			this.unlock();
		}
		if (found) {
			return true;
		} else {
			return false;
		}
	},

	getNextPage: function(type) {

		if (this.numberOfPages > this.currentPage) {
			++this.currentPage;
			var myHref = this.fbUrl + "&page=" + this.currentPage;
			this.getContent(myHref);
		} else {
			this.allFinished = true;
			this.generateStateMessage(type);
		}
		return true;
	},

	getContent: function(myHref) {

		FeedbackFox.http_request_content = new XMLHttpRequest();
		FeedbackFox.http_request_content.timeout = 3; // 3 seconds
		FeedbackFox.http_request_content.onreadystatechange = this.processContent;
		FeedbackFox.http_request_content.open('GET', myHref, true);
		FeedbackFox.http_request_content.send(null);
	},

	processContent: function() {

		var contentDoc = "";
		try {
			if (FeedbackFox.http_request_content.readyState == 4) {
				if (FeedbackFox.http_request_content.status == 200) {
					contentDoc = FeedbackFox.http_request_content.responseText;
					if (contentDoc) {
						if (!FeedbackFox.firstPageProcessed) {
							// look for number of pages we have to get
							FeedbackFox.getNumberOfPages(contentDoc);
							FeedbackFox.firstPageProcessed = true;
						}
						var ready = FeedbackFox.extractComments(contentDoc);
						if (ready) {
							var value = 100 / FeedbackFox.numberOfPages * FeedbackFox.currentPage;
							FeedbackFox.setProgressbar(value + "");
							FeedbackFox.getNextPage();
						}
					}
				}
			}
		} catch (e) {
			//alert(e);
			FeedbackFox.log("processContent: " + e);
		}
	},

	extractComments: function(page) {

		var detail = "";
		var userLeft = "";
		var sellbuy = "";
		var date = "";
		var comment = "";
		var link = "";
		var item = "";
		var sorttype = 0;
		this.regexStringBundle = document.getElementById("fbf-regex-bundle");
		var header = this.regexStringBundle.getString('header');
		header = new RegExp(header);
		var trreg = this.regexStringBundle.getString('trreg');
		trreg = new RegExp(trreg, "g");
		var tablebegin = this.regexStringBundle.getString('tablebegin');
		tablebegin = new RegExp(tablebegin);
		var tableclass = this.regexStringBundle.getString('tableclass');
		tableclass = new String(tableclass);
		var tdreg = this.regexStringBundle.getString('tdreg');
		tdreg = new RegExp(tdreg, "g");
		this.characteristic = this.prefService.getCharPref("extensions.feedbackfox.characteristic");
		try {
			var table = page.substring(page.indexOf(tableclass));
			var rows = table.match(trreg);
			for ( var i = 0; i < rows.length; i++) {
				if (i < this.maxfeedbackcount) {
					var row = rows[i];
					row = row.replace(header, "");
					var rowreplpre = this.regexStringBundle.getString('rowreplpre');
					rowreplpre = new RegExp(rowreplpre);
					var rowreplpost = this.regexStringBundle.getString('rowreplpost');
					rowreplpost = new RegExp(rowreplpost);
					row = row.replace(rowreplpre, "").replace(rowreplpost, "");
					var td = row.match(tdreg);
					var detailregex = this.regexStringBundle.getString('detailregex');
					detailregex = new RegExp(detailregex);
					var sellbuyregex = this.regexStringBundle.getString('sellbuyregex');
					sellbuyregex = new RegExp(sellbuyregex);
					var userleftregex = this.regexStringBundle.getString('userleftregex');
					userleftregex = new RegExp(userleftregex);
					if (td[0].match(detailregex)) {
						detail = td[0].match(detailregex)[1];
						if (detail.toLowerCase().match(/positive/)) {
							detail = 'positive';
							sorttype = 4;
						} else if (detail.toLowerCase().match(/negative/)) {
							detail = 'negative';
							sorttype = 1;
						} else if (detail.toLowerCase().match(/neutral/)) {
							detail = 'neutral';
							sorttype = 2;
						}
					} else {
						detail = 'withdrawn';
						sorttype = 3;
					}
					comment = td[1].replace(/<td.*?>/, "").replace(/<\/td>/, "");
					try {
						sellbuy = td[2].match(sellbuyregex)[1];
						userLeft = td[2].match(userleftregex)[1];
						sellbuy = sellbuy.replace(/<div.*?><a href=\"http/, "unknown");
						if (sellbuy.match(/Seller/)) {
							sellbuy = this.seller;
						} else if (sellbuy.match(/Buyer/)) {
							sellbuy = this.buyer;
						} else {
							sellbuy = '--';
						}
					} catch (e) {
						this.log("sellbuy problem: " + e);
					}
					date = td[3].replace(/<td.*?>/, "").replace(/<\/td>/, "");
					var tmpDate = "";
					if (date.match(/(...)-(\d\d)-(\d\d) (\d\d):(\d\d)/)) {
						tmpDate = date.match(/(...)-(\d\d)-(\d\d) (\d\d):(\d\d)/);
						var dateObj = new Date();
						dateObj.setDate(parseInt(tmpDate[2]));
						dateObj.setMonth(this.getMonth(tmpDate[1]));
						tmpDate[3] = (parseInt(tmpDate[3]) > 69) ? "19"
								+ tmpDate[3] : "20" + tmpDate[3];
						dateObj.setFullYear(parseInt(tmpDate[3]));
						dateObj.setHours(parseInt(tmpDate[4]));
						dateObj.setMinutes(parseInt(tmpDate[5]));
						date = this.localizeDate(dateObj);
					}
					try {
						item = td[5].match(/\(#(\d+)\)/)[1];
					} catch (e) {
						item = td[7].replace(/<td.*?>/, "").replace(/<\/td>/, "");
					}
					try {
						// -- (#1234567890)
						item = item.match(/-- \(\#(\d+)\)/)[1];
					} catch (e) {
					}
					if (item.match(/Private/) || item.match(/--/)) {
						item = this.privateAuction;
					}

					// === add feedback ===
					var feedback = new Array();
					feedback.push(detail); // 0
					feedback.push(comment); // 1
					feedback.push(this.characteristic == 'sellbuy' ? sellbuy : userLeft); // 2
					feedback.push(date); // 3
					feedback.push(item); // 4
					feedback.push(link); // 5
					feedback.push(sorttype);// 6
					feedback.push(false); // 7
					this.addCommentRow(feedback);
					// reset
					detail = "";
					comment = "";
					sellbuy = "";
					userLeft = "";
					date = "";
					item = "";
					link = "";
				}
			}
		} catch (e) {
			this.log("extractComments: " + e);
		}
		return true;
	},

	getMonth: function(month) {

		if (month == 'Jan')
			return 0;
		else if (month == 'Feb')
			return 1;
		else if (month == 'Mar')
			return 2;
		else if (month == 'Apr')
			return 3;
		else if (month == 'May')
			return 4;
		else if (month == 'Jun')
			return 5;
		else if (month == 'Jul')
			return 6;
		else if (month == 'Aug')
			return 7;
		else if (month == 'Sep')
			return 8;
		else if (month == 'Oct')
			return 9;
		else if (month == 'Nov')
			return 10;
		else if (month == 'Dec')
			return 11;

		return -1;
	},

	localizeDate: function(date) {
		this.tld = this.getTLD();
		var millis = date.getTime();
		var correction = this.calculateTimeShift();
		millis += correction;
		date.setTime(millis);
		var day = date.getDate();
		if (day < 10) {
			day = "0" + day;
		}
		var month = date.getMonth() + 1;
		if (month < 10) {
			month = "0" + month;
		}
		var year = date.getYear();
		if (year >= 100) {
			year -= 100;
		}
		if (year < 10) {
			year = "0" + year;
		}
		var localeDate = "";
		if ((this.tld == 'co.uk') || (this.tld == 'fr') || (this.tld == 'it')) {
			localeDate = day + "-" + months[date.getMonth()] + "-" + year;
		} else if (this.tld == 'de') {
			localeDate = day + "." + month + "." + year;
		} else if ((this.tld == 'es') || (this.tld == 'nl')) {
			localeDate = day + "-" + months[date.getMonth()].toLowerCase() + "-" + year;
		} else {
			localeDate = months[date.getMonth()] + "-" + day + "-" + year;
		}
		var hours = date.getHours();
		if (hours < 10) {
			hours = "0" + hours;
		}
		var minutes = date.getMinutes();
		if (minutes < 10) {
			minutes = "0" + minutes;
		}
		localeDate += " " + hours + ":" + minutes;
		return localeDate;
	},

	calculateTimeShift: function() {
		var l = this.prefService.getCharPref("general.useragent.locale");
		l = (l.length > 2) ? l.substring(3).toLowerCase() : l.toLowerCase();
		var correction = 0;
		switch (l) {
		case "at": // +9h
			correction = 32400;
			break;
		case "ch": // +9h
			correction = 32400;
			break;
		case "de": // +9h
			correction = 32400;
			break;
		case "au": // +17h
			correction = 61200;
			break;
		case "ca": // +3h
			correction = 10800;
			break;
		case "gb": // +8h
			correction = 28800;
			break;
		case "ie": // +8h
			correction = 28800;
			break;
		case "in": // +13h
			correction = 46800;
			break;
		case "sg": // +6h
			correction = 21600;
			break;
		case "es": // +9h
			correction = 32400;
			break;
		case "it": // +9h
			correction = 32400;
			break;
		case "fr": // +9h
			correction = 32400;
			break;
		case "be": // +9h
			correction = 32400;
			break;
		case "nl": // +9h
			correction = 32400;
			break;
		case "pl": // +9h
			correction = 32400;
			break;
		case "cn": // +15h
			correction = 54000;
			break;
		default: // eBay headquarter
			correction = 0;
			break;
		}
		correction = correction * 1000;
		return correction;
	},

	addCommentRow: function(feedback) {

		FbfTree.addItem([ feedback[0], feedback[1], feedback[2], feedback[3], feedback[4], feedback[5], feedback[6], feedback[7] ]);
		this.fbCount++;
	},

	processRowSelection: function(row) {

		var table = FbfTree.getDataTable();
		if (table[row]) {
			var item = table[row][4];
			if (item != this.privateAuction) {
				this.tld = this.getTLD();
				var link = "http://cgi.ebay." + this.tld
						+ "/ws/eBayISAPI.dll?ViewItem&item=" + item;
				this.topWin = this.windowMediator.getMostRecentWindow("navigator:browser");
				this.browser = this.topWin.getBrowser();
				if (link.length > 5) {
					// add a new tab and open item link
					if (this.itemTab) {
						this.browser.selectedTab = this.itemTab;
						this.browser.loadURI(link);
					} else {
						this.itemTab = this.browser.addTab(link);
						this.browser.selectedTab = this.itemTab;
					}
				} else {
					this.tmp = document.getElementById('info_state').getAttribute('value');
					this.setState(this.itemnotavailable);
				}
			} else {
				this.setState(this.noitemview);// TODO
			}
		}
	},

	reset: function() {
		this.numberOfPages = 1;
		this.statePanel = null;
		this.fbUrl = "";
		this.pagesContent = "";
		this.fbCount = 0;
		this.http_request_content = false;
		this.type = "";
		this.firstPageProcessed = false;
		this.allFinished = false;
		this.currentPage = 1;
		this.itemTab = null;
		this.tmp = "";
		try {
			FbfTree.resetTree();
		} catch (e) {}
	},

	setState: function(text) {
		this.switchStatePanel('info');
		if (text == this.itemnotavailable) {
			this.setTout(function() { FeedbackFox.setState(); }, 1000);
		}
		this.statePanel = document.getElementById('info_state');
		if (this.statePanel) {
			if (text) {
				this.statePanel.setAttribute('value', text);
				this.notify(text);
			} else {
				this.statePanel.setAttribute('value', this.tmp);
				this.notify(this.tmp);
			}
			return true;
		}
		return false;
	},

	setProgressbar: function(value) {

		this.progress = document.getElementById('progress_state');
		this.progress.setAttribute('value', value);
	},

	switchStatePanel: function(type) {

		this.progress = document.getElementById('progress_state');
		this.statePanel = document.getElementById('info_state');
		var sp1 = document.getElementById('sp1');
		var sp2 = document.getElementById('sp2');
		if (type == 'progress') {
			this.progress.hidden = false;
			sp1.hidden = true;
			this.statePanel.hidden = true;
			sp2.hidden = true;
		} else if (type == 'info') {
			this.progress.hidden = true;
			sp1.hidden = false;
			this.statePanel.hidden = false;
			sp2.hidden = false;
		}
	},

	openOptionsWindow: function() {
		if (!(this.optWnd && this.optWnd.document))
			this.optWnd = openDialog("chrome://feedbackfox/content/options.xul", "",
					"chrome,titlebar,toolbar,centerscreen,dialog=no");
		else
			this.optWnd.focus();
	},

	openHelpWindow: function() {
		openHelp('introduction', 'chrome://feedbackfox/content/feedbackfoxhelp.rdf');
	},
	
	setTout: function(fn, tout) {
		window.setTimeout(fn, parseInt(tout));
	}

};

window.addEventListener('load', function() { FeedbackFox.init(); }, false);
window.addEventListener('load', function() { FeedbackFox.registerContextMenuListener(); }, true);
